﻿//=================================================================
//  A c t i o n s c r i p t    C o m m a n d    I n t e r f a c e
//
//                           f o r
//
//        m P r o j e c t o r   f o r   M a c i n t o s h  
//
// Copyright 2004 ScreenTime Media
//
// mProjector.as extends the ScreenTime for Flash screen saver and 
// your screen saver swf.  
//-----------------------------------------------------------------
//  S e t u p
//
// To use these scripts you must include this file in your movie.
// Simplest method:
// 1. Place a copy of this file in the same folder as your Flash
//    movie (.fla) file.
// 2. Add this line to the first frame of the top or main timeline
//   action script:
//    #include "mProjector_commands.as"
//
/*=================================================================

mApplication.checkNetConnection (isConnected_returnVarName) 
<> isConnected_returnVarName - Name of variable at the root level where the return value (notConnected=0, connected=1) will be stored. If no variable name is specified, the result will be stored in _root.isConnected.

mApplication.downloadFile = function(fileName, URL, progressObject, progressFunction, downloadSuccessful_returnVarName)
<> fileName - Name of local file where the downloaded file should be saved. File will be placed next to saver.swf. The filename can include a subpath i.e. "jpgs/planets/mars.jpg"
<> URL - URL of the remote file to be downloaded.
<> progressObject - Not yet implemented. Pass an empty string.
<> progressFunction - Not yet implemented. Pass an empty string.
<> downloadSuccessful_returnVarName - Name of the variable to store result (downloadSuccessful=0, downloadSuccessful=1). If no variable name is specified, the result will be stored in _root.downloadSuccessful.

mSystem.setActiveWallpaper (fileName, tileOrCenterOrStretch)
<> fileName - wallpaper file name or relative path from main swf to file. Path is relative to the saver.swf -- a/b/temp.jpg.
<> tileOrCenterOrStretch - display image "tile" or "center" or "stretch". Mac always sets image to stretch.

mApplication.quit ()
=================================*/

if (_global.mProjector == null) {
	_global.mProjector = new Object();
	_global.mProjector.version = "1.0.1";
	var system_str = System.capabilities.os.toLowerCase();
	if (system_str.indexOf("windows")>=0) {
		_global.mProjector.platform_str = "Windows";
	} else if (system_str.indexOf("mac")>=0) {
		_global.mProjector.platform_str = "Mac";
	} else {
		_global.mProjector.platform_str = "";
	}
	_global.mProjector.debugTraceOn = false;

var NO_ERROR = 0;
var ERROR = -1;

_global.mProjector.debugTrace = function(traceMessage) {
	if ((this.debugTraceOn) && (this.platform_str == "Mac")) {		
		var param_str = "DEBUG TRACE -- url sent: " + escape(traceMessage);
		param_str = "ST://ST_mApplication.trace?msg="+param_str;
		loadVariables("\""+param_str+"\"", _root);
	}
};
_global.mProjector.enableDebugTrace = function(debugTraceOn) {
	this.debugTraceOn = debugTraceOn;
	_global.mApplication.autoTrace("enableDebugTrace", arguments);
};

_global.mProjector.sendAction = function(command_str, param_str) {
	var url_str:String;
	var errorMessage;
	if (param_str == undefined) {param_str = "";}
	
	url_str = command_str + param_str;
	if (this.platform_str == "Windows") {
		this.debugTrace(url_str);
		fscommand(command_str, param_str);
	} else if (this.platform_str == "Mac") {
		url_str = "ST://ST_" + url_str;
		this.debugTrace(url_str);
		loadVariables(url_str, _root);
	} else {
		var tempMessage = "ST commands: This functionality";
		tempMessage += " is currently implemented in Windows and MacOS only.";
		tempMessage += newline+" -> "+command_str+" "+parameters_str;
		this.debugTrace(tempMessage);
	}
}

// mApplication commands
if (_global.mApplication == null) {
_global.mApplication = new Object();
_global.mApplication.traceOn = false;
_global.mApplication.autoTraceOn = false;

_global.mApplication.trace = function(traceMessage) {
		trace(traceMessage);
		var param_str = "ST://ST_mApplication.trace?msg="+traceMessage
		loadVariables(param_str, _root);
};

_global.mApplication.autoTrace = function(functionName, args) {
	if (this.autoTraceOn) {
		var param_str = "";
		var args_str = "";		
		
		if (args != undefined) {args_str = args.toString();} 		
		param_str = functionName + "(" + args_str + ")";
		param_str = "ST://ST_mApplication.trace?msg="+param_str;
		loadVariables(param_str, _root);
	}
};
_global.mApplication.enableAutoTrace = function(autoTraceOn) {
	_global.mApplication.autoTraceOn = autoTraceOn;
	this.autoTrace("enableAutoTrace", arguments);
};


_global.mApplication.downloadFile = function(fileName, URL, progressObject, progressFunction, downloadSuccessful_returnVarName) {
	var param_str;
	
	_global.mApplication.autoTrace("downloadFile", arguments);
	if ((downloadSuccessful_returnVarName == undefined) || (downloadSuccessful_returnVarName.length == 0)) {
			downloadSuccessful_returnVarName = "downloadSuccessful";
	}
	//param_str = "?fileName="+fileName+"&URL="+URL+"&progressObject="+progressObject+"&progressFunction="+progressFunction+"&returnVarName1="+downloadSuccessful_returnVarName;
	param_str = "?fileName="+fileName+"&URL="+URL+"&returnVarName1="+downloadSuccessful_returnVarName;
	mProjector.sendAction("mApplication.downloadFile", param_str);
};

_global.mApplication.checkNetConnection = function(isConnected_returnVarName) {
	var param_str;
	
	_global.mApplication.autoTrace("checkNetConnection", arguments);
	if ((isConnected_returnVarName == undefined) || (isConnected_returnVarName.length == 0)) {
			isConnected_returnVarName = "isConnected";
	}
	param_str = "?returnVarName1="+isConnected_returnVarName;
	mProjector.sendAction("mApplication.checkNetConnection", param_str);
};
_global.mApplication.quit = function() {
	_global.mApplication.autoTrace("quit", arguments);
	mProjector.sendAction("mApplication.quit");
};
_global.mApplication.revealInFinder = function() {
	_global.mApplication.autoTrace("revealInFinder", arguments);
	mProjector.sendAction("mApplication.revealInFinder");
};
}

// mFile commands
if (_global.mFile == null) {
//	mApplication.trace("creating mac mFile object");
_global.mFile = new Object();
_global.mFile.deleteFile = function(fileName, success_returnVarName) {
	var param_str;
	_global.mApplication.autoTrace("deleteFile", arguments);
	if ((success_returnVarName == undefined) || (success_returnVarName.length == 0)) {
		success_returnVarName = "success";
	}
	param_str = "?fileName="+fileName + "&returnVarName1="+success_returnVarName;
	mProjector.sendAction("mFile.deleteFile", param_str);
};
_global.mFile.deleteFolder = function(folderName, success_returnVarName) {
	var param_str;
	_global.mApplication.autoTrace("deleteFolder", arguments);
	if ((success_returnVarName == undefined) || (success_returnVarName.length == 0)) {
		success_returnVarName = "success";
	}
	param_str = "?folderName="+folderName + "&returnVarName1="+success_returnVarName;	
	mProjector.sendAction("mFile.deleteFolder", param_str);
};
_global.mFile.copyFile = function(sourceFile, destinationFile, success_returnVarName) {
	var param_str;
	_global.mApplication.autoTrace("copyFile", arguments);
	if ((success_returnVarName == undefined) || (success_returnVarName.length == 0)) {
		success_returnVarName = "success";
	}
	param_str ="?source="+sourceFile+"&dest="+destinationFile + "&returnVarName1="+success_returnVarName;	
	mProjector.sendAction("mFile.copyFile", param_str);
};
_global.mFile.createFolder = function(folderName, success_returnVarName) {
	var param_str;
	_global.mApplication.autoTrace("createFolder", arguments);
	if ((success_returnVarName == undefined) || (success_returnVarName.length == 0)) {
		success_returnVarName = "success";
	}
	param_str = "?folderName="+folderName + "&returnVarName1="+success_returnVarName;
	mProjector.sendAction("mFile.createFolder", param_str);
};
_global.mFile.renameFile = function(oldFileName, newFileName, success_returnVarName) {
	var param_str;
	_global.mApplication.autoTrace("renameFile", arguments);
	if ((success_returnVarName == undefined) || (success_returnVarName.length == 0)) {
		success_returnVarName = "success";
	}
	param_str = "?oldFileName="+oldFileName+"&newFileName"+newFileName + "&returnVarName1="+success_returnVarName;
	mProjector.sendAction("mFile.renameFile", param_str);
};
_global.mFile.copyFolder = function(sourceFolder, destinationFolder, success_returnVarName) {
	var param_str;
	_global.mApplication.autoTrace("copyFolder", arguments);
	if ((success_returnVarName == undefined) || (success_returnVarName.length == 0)) {
		success_returnVarName = "success";
	}
	param_str = "?sourceFolder="+sourceFolder+"&destinationFolder"+destinationFolder + "&returnVarName1="+success_returnVarName;
	mProjector.sendAction("mFile.copyFolder", param_str);
};
_global.mFile.createShortcut = function(targetFile, arguments, shortcutFile, description, iconFile, iconNumber, success_returnVarName) {
	var param_str;
	_global.mApplication.autoTrace("createShortcut", arguments);
	if ((success_returnVarName == undefined) || (success_returnVarName.length == 0)) {
		success_returnVarName = "success";
	}
	param_str = "?targetFile="+targetFile+"&shortcutFile="+shortcutFile + "&returnVarName1="+success_returnVarName;
	mProjector.sendAction("mFile.createShortcut", param_str);
};
_global.mFile.writeString = function(fileName, textToWrite, success_returnVarName) {
	var param_str;
	_global.mApplication.autoTrace("writeString", arguments);
	if ((success_returnVarName == undefined) || (success_returnVarName.length == 0)) {
		success_returnVarName = "success";
	}
	param_str = "?fileName="+fileName+"&textToWrite="+textToWrite + "&returnVarName1="+success_returnVarName;
	mProjector.sendAction("mFile.writeString", param_str);
};
_global.mFile.readString = function(fileName, readStr_returnVarName) {
	var param_str;
	_global.mApplication.autoTrace("readFile", arguments);
	if ((readStr_returnVarName == undefined) || (readStr_returnVarName.length == 0)) {
			readStr_returnVarName = "readStr";
	}
	var param_str = "?fileName="+fileName+"&returnVarName1="+readStr_returnVarName;
	mProjector.sendAction("mFile.readFile", param_str);
};
}

// mWindow commands
if (_global.mWindow == null) {
//	mApplication.trace("creating mac mFile object");
_global.mWindow = new Object();
_global.mWindow.minimize = function() {
	_global.mApplication.autoTrace("minimize", arguments);
	mProjector.sendAction("mWindow.minimize");
};
_global.mWindow.restore = function() {
	_global.mApplication.autoTrace("restore", arguments);
	mProjector.sendAction("mWindow.restore");
};
_global.mWindow.setBackgroundColor = function(color) {
	var param_str = "?color="+color;
	_global.mApplication.autoTrace("setBackgroundColor", arguments);
	mProjector.sendAction("mWindow.setBackgroundColor", param_str);
};
_global.mWindow.setMaskRectangle = function(left, top, right, bottom) {
	var param_str = "?left="+left+"&top="+top+"&right="+right+"&bottom="+bottom;
	_global.mApplication.autoTrace("setMaskRectangle", arguments);
	mProjector.sendAction("mWindow.setMaskRectangle", param_str);
};
_global.mWindow.setMaskTiff = function(fileName) {
	var param_str = "?fileName="+fileName;
	_global.mApplication.autoTrace("setMaskTiff", arguments);
	mProjector.sendAction("mWindow.setMaskTiff", param_str);
};
_global.mWindow.setPosition = function(x, y) {
	var param_str = "?x="+x+"&y="+y;
	_global.mApplication.autoTrace("setPosition", arguments);
	mProjector.sendAction("mWindow.setPosition", param_str);
};
_global.mWindow.getPosition = function(returnVarName_x, returnVarName_y) {
	var param_str;
	
	_global.mApplication.autoTrace("getPosition", arguments);
	if ((returnVarName_x == undefined) || (returnVarName_x.length == 0)) {
			returnVarName_x = "x";
	}
	if ((returnVarName_y == undefined) || (returnVarName_y.length == 0)) {
			returnVarName_y = "y";
	}
	var param_str = "?returnVarName1="+returnVarName_x+"&returnVarName2="+returnVarName_y;
	mProjector.sendAction("mWindow.getPosition", param_str);
};
_global.mWindow.setSize = function(width, height) {
	var param_str = "?width="+width+"&height="+height;
	_global.mApplication.autoTrace("setSize", arguments);
	mProjector.sendAction("mWindow.setSize", param_str);
};
_global.mWindow.getSize = function(width_returnVarName, height_returnVarName) {
	var param_str;
	
	_global.mApplication.autoTrace("getSize", arguments);
	if ((width_returnVarName == undefined) || (width_returnVarName.length == 0)) {
			width_returnVarName = "width";
	}
	if ((height_returnVarName == undefined) || (height_returnVarName.length == 0)) {
			height_returnVarName = "height";
	}
	param_str = "?returnVarName1="+width_returnVarName+"&returnVarName2="+height_returnVarName;
	mProjector.sendAction("mWindow.getSize", param_str);
};
_global.mWindow.setTitle = function(title) {
	var param_str = "?title="+title;
	_global.mApplication.autoTrace("setTitle", arguments);
	mProjector.sendAction("mWindow.setTitle", param_str);
};
_global.mWindow.setZOrder = function(order) {
	var param_str = "?order="+order;
	_global.mApplication.autoTrace("setZOrder", arguments);
	mProjector.sendAction("mWindow.setZOrder", param_str);
};
_global.mWindow.minimize = function() {
	_global.mApplication.autoTrace("minimize", arguments);
	mProjector.sendAction("mWindow.minimize");
};
_global.mWindow.show = function(show) {
	var param_str = "?show="+show;
	_global.mApplication.autoTrace("show", arguments);
	mProjector.sendAction("mWindow.show", param_str);
};
_global.mWindow.startDrag = function() {
	_global.mApplication.autoTrace("startDrag", arguments);
	mProjector.sendAction("mWindow.startDrag");
};
_global.mWindow.stopDrag = function() {
	_global.mApplication.autoTrace("stopDrag", arguments);
	mProjector.sendAction("mWindow.stopDrag");
};
}

// mSystem commands
if (_global.mSystem == null) {
//	mApplication.trace("_global.mSystem == null");
_global.mSystem = new Object();
_global.mSystem.executeApplication = function(application, parameters, show) {
	var param_str = "?application="+application+"&parameters="+parameters+"&show="+show;
	_global.mApplication.autoTrace("executeApplication", arguments);
	mProjector.sendAction("mSystem.executeApplication", param_str);
};
_global.mSystem.getPathToBundledApplication = function(application, bundledApplicationPath_returnVarName) {
	var param_str;
	
	_global.mApplication.autoTrace("getPathToBundledApplication", arguments);
	if ((bundledApplicationPath_returnVarName == undefined) || (bundledApplicationPath_returnVarName.length == 0)) {
			bundledApplicationPath_returnVarName = "bundledApplicationPath";
	}
	param_str = "?application="+application+"&returnVarName1="+bundledApplicationPath_returnVarName;
	mProjector.sendAction("mSystem.getPathToBundledApplication", param_str);
};
_global.mSystem.getPathToBundledFile = function(fileName, bundledFilePath_returnVarName) {
	var param_str;
	
	_global.mApplication.autoTrace("getPathToBundledFile", arguments);
	if ((bundledFilePath_returnVarName == undefined) || (bundledFilePath_returnVarName.length == 0)) {
			bundledFilePath_returnVarName = "bundledFileNamePath";
	}
	param_str = "?fileName="+fileName+"&returnVarName1="+bundledFilePath_returnVarName;
	
	mProjector.sendAction("mSystem.getPathToBundledFile", param_str);
};
_global.mSystem.isApplicationRunning = function(application, isRunning_returnVarName) {
	var param_str;
	
	_global.mApplication.autoTrace("isApplicationRunning", arguments);
	if ((isRunning_returnVarName == undefined) || (isRunning_returnVarName.length == 0)) {
			isRunning_returnVarName = "isRunning";
	}
	param_str = "?application="+application+"&returnVarName1="+isRunning_returnVarName;
	mProjector.sendAction("mSystem.isApplicationRunning", param_str);
};
_global.mSystem.setActiveWallpaper = function(fileName, tileOrCenterOrStretch) {
	var displayMethod, param_str;
	displayMethod = tileOrCenterOrStretch.toUpperCase();
	switch (displayMethod) {
	case "TILE" :
	case "CENTER" :
	case "STRETCH" :
		// displayMethod = tileOrCenterOrStretch;
		break;
	default :
		displayMethod = "CENTER";
		break;
	}
	_global.mApplication.autoTrace("setActiveWallpaper", arguments);
	param_str = "?fileName="+fileName+"&tileOrCenterOrStretch="+displayMethod;
	mProjector.sendAction("mSystem.setActiveWallpaper", param_str);
};

_global.mSystem.setActiveScreenSaver = function(name) {
	var param_str = "?name="+name;
	_global.mApplication.autoTrace("setActiveScreenSaver", arguments);
	mProjector.sendAction("mSystem.setActiveScreenSaver", param_str);
};
_global.mSystem.runAppleScript = function(script) {
	var param_str = "?script="+script;
	_global.mApplication.autoTrace("runAppleScript", arguments);
	mProjector.sendAction("mSystem.runAppleScript", param_str);
};
_global.mSystem.setStartAtLogin = function(start) {
	var param_str = "?start="+start;
	_global.mApplication.autoTrace("setStartAtLogin", arguments);
	mProjector.sendAction("mSystem.setStartAtLogin", param_str);
};
_global.mSystem.getStartAtLogin = function(start_returnVarName) {
	var param_str;
	
	_global.mApplication.autoTrace("getStartAtLogin", arguments);
	if ((start_returnVarName == undefined) || (start_returnVarName.length == 0)) {
			start_returnVarName = "start";
	}
	param_str = "?returnVarName1="+start_returnVarName;
	mProjector.sendAction("mSystem.getStartAtLogin");
};
_global.mSystem.chooseFile = function(title, initFileName, folderName, filter, defaultExtension, fileMustExist, saveFile, fileName_returnVarName) {
	var param_str;
	
	_global.mApplication.autoTrace("chooseFile", arguments);
	if ((fileName_returnVarName == undefined) || (fileName_returnVarName.length == 0)) {
			fileName_returnVarName = "fileName";
	}
	param_str = "?title="+title+"&initFileName="+initFileName+"&folderName="+folderName+"&filter="+filter+"&fileMustExist="+fileMustExist+"&saveFile="+saveFile+"&returnVarName1="+fileName_returnVarName;
	mProjector.sendAction("mSystem.chooseFile", param_str);
};

_global.mSystem.chooseFolder = function(title, initFolderName, folderName_returnVarName) {
	var param_str;
	
	_global.mApplication.autoTrace("chooseFolder", arguments);
	if ((folderName_returnVarName == undefined) || (folderName_returnVarName.length == 0)) {
			folderName_returnVarName = "folderName";
	}

	var param_str = "?title="+title+"&initFolderName="+initFolderName+"&returnVarName1="+folderName_returnVarName;
	mProjector.sendAction("mSystem.chooseFolder", param_str);
};
}

// mMenu commands
if (_global.mMenu == null) {
//	mApplication.trace("_global.mMenu == null");
_global.mMenu = new Object();
_global.mMenu.createMenu = function(menuName) {
	var param_str = "?menuName="+menuName;
	_global.mApplication.autoTrace("createMenu", arguments);
	mProjector.sendAction("mMenu.createMenu", param_str);
};
_global.mMenu.deleteMenu = function(menuName) {
	var param_str = "?menuName="+menuName;
	_global.mApplication.autoTrace("deleteMenu", arguments);
	mProjector.sendAction("mMenu.deleteMenu", param_str);
};
_global.mMenu.addMenuToMenuBar = function(menuName) {
	var param_str = "?menuName="+menuName;
	_global.mApplication.autoTrace("addMenuToMenuBar", arguments);
	mProjector.sendAction("mMenu.addMenuToMenuBar", param_str);
};
_global.mMenu.addZOrderMenuItems = function(show, menuName) {
	var param_str = "?menuName="+menuName+"&show="+show;
	_global.mApplication.autoTrace("addZOrderMenuItems", arguments);
	mProjector.sendAction("mMenu.addZOrderMenuItems", param_str);
};
_global.mMenu.addItem = function(itemName, menuName) {
	var param_str = "?menuName="+menuName+"&itemName="+itemName;
	_global.mApplication.autoTrace("addItem", arguments);
	mProjector.sendAction("mMenu.addItem", param_str);
};
_global.mMenu.addWebLinkToMenu = function(itemName, url, menuName) {
	var param_str = "?menuName="+menuName+"&itemName="+itemName+"&url="+url;
	_global.mApplication.autoTrace("addWebLinkToMenu", arguments);
	mProjector.sendAction("mMenu.addWebLinkToMenu", param_str);
};
_global.mMenu.addSeparator = function(menuName) {
	var param_str = "?menuName="+menuName;
	_global.mApplication.autoTrace("addSeparator", arguments);
	mProjector.sendAction("mMenu.addSeparator", param_str);
};
_global.mMenu.checkItem = function(itemPosition, check, menuName) {
	var param_str = "?menuName="+menuName+"&itemPosition="+itemPosition+"&check="+check;
	_global.mApplication.autoTrace("checkItem", arguments);
	mProjector.sendAction("mMenu.checkItem", param_str);
};
_global.mMenu.removeAllItems = function(menuName) {
	var param_str = "?menuName="+menuName;
	_global.mApplication.autoTrace("removeAllItems", arguments);
	mProjector.sendAction("mMenu.removeAllItems", param_str);
};
}
}